import torch
from PIL import Image
import cv2

WEIGHTS = "py_doc/yolov7/weights/yolov7x-100.pt"

def get_yolov7(weight_path):
    torch.hub._validate_not_a_forked_repo=lambda a,b,c: True
    model = torch.hub.load("py_doc/yolov7/", "custom", weight_path, force_reload=True, trust_repo=True, source='local')

    if isinstance(model, dict):
        model = model['ema' if model.get('ema') else 'model']
    model.conf = 0.5
    return model

def detect_document(image, model=WEIGHTS):
    model = get_yolov7(model)
    result = model(image).pred[0]
    if torch.cuda.is_available():
        result = result.cpu().numpy()
    else:
        result = result.numpy()
    return result